#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
from qt import *
from etform import eventTestForm

try:
    False
except NameError:
    False = 0
    True = 1

GLOBAL_EVENT_FILTER = 1
    
class eventTest(eventTestForm):
    def __init__(self, *args):
        eventTestForm.__init__(self, *args)
        # FIXME: these are workarounds, because Qt3 doesn't emit Focus{In,Out} 
        # events for combo widgets, as Q{Date,Time}Edit. Either install a global 
        # qApp eventFilter, which catches all events (apparently not that nice.. 
        # and could present problems in dtors),
        # or install event filters on the focusProxy of those combo widgets.
        if GLOBAL_EVENT_FILTER:
            qApp.installEventFilter(self)
        else:
            for w in (self.deDate, self.teTime, self.dteDateTime, self.lineEdit1,
                    self.cbAllEvents, self.pbClose):
                fp = w.focusProxy()
                if fp:
                    fp.installEventFilter(self)
                else:
                    w.installEventFilter(self)

        self.versionLabel.setText("Qt: %s, PyQt: %s, Python %s" 
                    % (QT_VERSION_STR, PYQT_VERSION_STR, sys.version.split()[0]))
        self.teLog.append("Note, how FocusIn events are missing for the "
                          "QDateEdit, QTimeEdit, and QDateTimeEdit widgets, "
                          "and for the latter even FocusOut events :-(..\n\n")
        self.cbAllEvents.setFocus()

    def eventFilter(self, obj, ev):
        if ev and obj:
            if ev.type() == QEvent.FocusIn:
                self.teLog.append("FocusIn on %s" % (obj.name()))
            elif ev.type() == QEvent.FocusOut:
                self.teLog.append("FocusOut on %s" % (obj.name()))
            elif self.cbAllEvents.isChecked():
                # With the global eventFilter, we need to "know" the names of the
                # some widgets, even they're qt internal, to prevent recursive
                # behavior until crash..
                if GLOBAL_EVENT_FILTER:
                    if obj.name() not in ('telog', 'qt_vbar', 'qt_viewport'):
                        self.teLog.append("Event %s on %s" % (ev.type(), obj.name()))
                else:
                    self.teLog.append("Event %s on %s" % (ev.type(), obj.name()))
        return False

if __name__ == "__main__":
    app = QApplication(sys.argv)
    win = eventTest()
    app.setMainWidget(win)
    win.show()
    ret = app.exec_loop()
    sys.exit(ret)
